package com.sa.ibiz.demo.demo.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.mapper.MsgAccountDetailMapper;
import com.sa.ibiz.demo.demo.domain.MsgAccountDetail;
import com.sa.ibiz.demo.demo.service.MsgAccountDetailService;
import com.sa.ibiz.demo.ibizutil.service.ServiceImplBase;
import com.sa.ibiz.demo.demo.service.dto.MsgAccountDetailSearchFilter;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import java.util.TreeMap;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import java.lang.reflect.Field;

import com.sa.ibiz.demo.demo.service.MsgAccountService;
import com.sa.ibiz.demo.demo.service.MsgAccountService;

/**
 * 实体[MsgAccountDetail] 服务对象接口实现
 */
@Service
public class MsgAccountDetailServiceImpl extends ServiceImplBase<MsgAccountDetailMapper, MsgAccountDetail> implements MsgAccountDetailService{

    @Autowired
    private MsgAccountService majormsgaccountService;
    @Autowired
    private MsgAccountService minormsgaccountService;

    @Resource
    private MsgAccountDetailMapper msgaccountdetailMapper;


    @Override
    public boolean create(MsgAccountDetail et) {
        this.beforeCreate(et);
         return super.create(et);
    }
    @Override
    public boolean update(MsgAccountDetail et){
        this.beforeUpdate(et);
		this.msgaccountdetailMapper.updateOne(et);
		this.get(et);
		return true;
    }

    public Object getEntityKey(MsgAccountDetail et){
		return et.getMsgaccountdetailid();  
    }

    @Override
    public boolean getDraft(MsgAccountDetail et)  {
    if((!StringUtils.isEmpty(et.getMajormsgaccountid())) && et.getMajormsgaccount() == null){
            try {
                et.setMajormsgaccount(majormsgaccountService.getById(et.getMajormsgaccountid()));
            }catch (Exception ex){}
        }
    if((!StringUtils.isEmpty(et.getMinormsgaccountid())) && et.getMinormsgaccount() == null){
            try {
                et.setMinormsgaccount(minormsgaccountService.getById(et.getMinormsgaccountid()));
            }catch (Exception ex){}
        }
            return true;
    }

	public List<MsgAccountDetail> listDefault(MsgAccountDetailSearchFilter filter) {
		return msgaccountdetailMapper.searchDefault(filter,filter.getSelectCond());
	}

	public Page<MsgAccountDetail> searchDefault(MsgAccountDetailSearchFilter filter) {
		return msgaccountdetailMapper.searchDefault(filter.getPage(),filter,filter.getSelectCond());
	}

    public  List<Map<String,Object>> selectRow(String sql){
       return msgaccountdetailMapper.selectRow(sql);
    }

 }